//-----------------------------------------------------------------------
// File : MRTRenderer.h
// Desc : Multiple Rendering Target Sample Program
// Copyright(c) Project Asura All right reserved.
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// History
//-----------------------------------------------------------------------
// <---> 2010/12/07 [Pocol] VK쐬.
// <End>

#ifndef __SAMPLE_RENDERER_H__
#define __SAMPLE_RENDERER_H__

//-----------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------
#include "AsDemoApp.h"
#include "AsShaderHelper.h"

namespace Schaft {
namespace Asura {
namespace SampleProgram {

/////////////////////////////////////////////////////////////////////////
// MRTRenderer class
/////////////////////////////////////////////////////////////////////////
class MRTRenderer : public IRenderer
{
	//-------------------------------------------------------------------
	// list of friend classes
	//-------------------------------------------------------------------
	/* NOTHING */

public:
	//-------------------------------------------------------------------
	// public variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// public methods
	//-------------------------------------------------------------------
	MRTRenderer();
	virtual ~MRTRenderer();
	bool Initialize();
	void PreRender();
	void Render();
	void RenderAlpha();
	void PostRender();
	void Release();

protected:
	//-------------------------------------------------------------------
	// protected variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// protected methods
	//-------------------------------------------------------------------
	/* NOTHING */

private:
	//-------------------------------------------------------------------
	// private variabless
	//-------------------------------------------------------------------
	GLuint mTexture[4];
    GLuint mFrameBuffer;
    GLuint mRenderBuffer;
    Schaft::Asura::Graphics::ICgEffect* mpEffect;

	//-------------------------------------------------------------------
	// private methods
	//-------------------------------------------------------------------
	/* NOTHING */
};

} // namespace SampleProgram
} // namespace Asura
} // namespace Schaft

#endif // __SAMPLE_RENDERER_H__